#[doc = r" Value read from the register"]
pub struct R {
    bits: u16,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u16,
}
impl super::TCD9_CITER_ELINKYES {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct CITER_LER {
    bits: u16,
}
impl CITER_LER {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct LINKCHR {
    bits: u8,
}
impl LINKCHR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = "Possible values of the field `ELINK`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ELINKR {
    #[doc = "The channel-to-channel linking is disabled"]
    _0,
    #[doc = "The channel-to-channel linking is enabled"]
    _1,
}
impl ELINKR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            ELINKR::_0 => false,
            ELINKR::_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> ELINKR {
        match value {
            false => ELINKR::_0,
            true => ELINKR::_1,
        }
    }
    #[doc = "Checks if the value of the field is `_0`"]
    #[inline]
    pub fn is_0(&self) -> bool {
        *self == ELINKR::_0
    }
    #[doc = "Checks if the value of the field is `_1`"]
    #[inline]
    pub fn is_1(&self) -> bool {
        *self == ELINKR::_1
    }
}
#[doc = r" Proxy"]
pub struct _CITER_LEW<'a> {
    w: &'a mut W,
}
impl<'a> _CITER_LEW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 511;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _LINKCHW<'a> {
    w: &'a mut W,
}
impl<'a> _LINKCHW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `ELINK`"]
pub enum ELINKW {
    #[doc = "The channel-to-channel linking is disabled"]
    _0,
    #[doc = "The channel-to-channel linking is enabled"]
    _1,
}
impl ELINKW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            ELINKW::_0 => false,
            ELINKW::_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _ELINKW<'a> {
    w: &'a mut W,
}
impl<'a> _ELINKW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ELINKW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The channel-to-channel linking is disabled"]
    #[inline]
    pub fn _0(self) -> &'a mut W {
        self.variant(ELINKW::_0)
    }
    #[doc = "The channel-to-channel linking is enabled"]
    #[inline]
    pub fn _1(self) -> &'a mut W {
        self.variant(ELINKW::_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u16) << OFFSET);
        self.w.bits |= ((value & MASK) as u16) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
    #[doc = "Bits 0:8 - Current Major Iteration Count"]
    #[inline]
    pub fn citer_le(&self) -> CITER_LER {
        let bits = {
            const MASK: u16 = 511;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u16) as u16
        };
        CITER_LER { bits }
    }
    #[doc = "Bits 9:12 - Minor Loop Link Channel Number"]
    #[inline]
    pub fn linkch(&self) -> LINKCHR {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u16) as u8
        };
        LINKCHR { bits }
    }
    #[doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete"]
    #[inline]
    pub fn elink(&self) -> ELINKR {
        ELINKR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u16) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:8 - Current Major Iteration Count"]
    #[inline]
    pub fn citer_le(&mut self) -> _CITER_LEW {
        _CITER_LEW { w: self }
    }
    #[doc = "Bits 9:12 - Minor Loop Link Channel Number"]
    #[inline]
    pub fn linkch(&mut self) -> _LINKCHW {
        _LINKCHW { w: self }
    }
    #[doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete"]
    #[inline]
    pub fn elink(&mut self) -> _ELINKW {
        _ELINKW { w: self }
    }
}
