#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PMPROT {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `AVLP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AVLPR {
    #[doc = "VLPR and VLPS are not allowed."]
    _0,
    #[doc = "VLPR and VLPS are allowed."]
    _1,
}
impl AVLPR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AVLPR::_0 => false,
            AVLPR::_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AVLPR {
        match value {
            false => AVLPR::_0,
            true => AVLPR::_1,
        }
    }
    #[doc = "Checks if the value of the field is `_0`"]
    #[inline]
    pub fn is_0(&self) -> bool {
        *self == AVLPR::_0
    }
    #[doc = "Checks if the value of the field is `_1`"]
    #[inline]
    pub fn is_1(&self) -> bool {
        *self == AVLPR::_1
    }
}
#[doc = "Possible values of the field `AHSRUN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AHSRUNR {
    #[doc = "HSRUN is not allowed"]
    _0,
    #[doc = "HSRUN is allowed"]
    _1,
}
impl AHSRUNR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AHSRUNR::_0 => false,
            AHSRUNR::_1 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AHSRUNR {
        match value {
            false => AHSRUNR::_0,
            true => AHSRUNR::_1,
        }
    }
    #[doc = "Checks if the value of the field is `_0`"]
    #[inline]
    pub fn is_0(&self) -> bool {
        *self == AHSRUNR::_0
    }
    #[doc = "Checks if the value of the field is `_1`"]
    #[inline]
    pub fn is_1(&self) -> bool {
        *self == AHSRUNR::_1
    }
}
#[doc = "Values that can be written to the field `AVLP`"]
pub enum AVLPW {
    #[doc = "VLPR and VLPS are not allowed."]
    _0,
    #[doc = "VLPR and VLPS are allowed."]
    _1,
}
impl AVLPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AVLPW::_0 => false,
            AVLPW::_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AVLPW<'a> {
    w: &'a mut W,
}
impl<'a> _AVLPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AVLPW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "VLPR and VLPS are not allowed."]
    #[inline]
    pub fn _0(self) -> &'a mut W {
        self.variant(AVLPW::_0)
    }
    #[doc = "VLPR and VLPS are allowed."]
    #[inline]
    pub fn _1(self) -> &'a mut W {
        self.variant(AVLPW::_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `AHSRUN`"]
pub enum AHSRUNW {
    #[doc = "HSRUN is not allowed"]
    _0,
    #[doc = "HSRUN is allowed"]
    _1,
}
impl AHSRUNW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AHSRUNW::_0 => false,
            AHSRUNW::_1 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AHSRUNW<'a> {
    w: &'a mut W,
}
impl<'a> _AHSRUNW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AHSRUNW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "HSRUN is not allowed"]
    #[inline]
    pub fn _0(self) -> &'a mut W {
        self.variant(AHSRUNW::_0)
    }
    #[doc = "HSRUN is allowed"]
    #[inline]
    pub fn _1(self) -> &'a mut W {
        self.variant(AHSRUNW::_1)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 5 - Allow Very-Low-Power Modes"]
    #[inline]
    pub fn avlp(&self) -> AVLPR {
        AVLPR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Allow High Speed Run mode"]
    #[inline]
    pub fn ahsrun(&self) -> AHSRUNR {
        AHSRUNR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 5 - Allow Very-Low-Power Modes"]
    #[inline]
    pub fn avlp(&mut self) -> _AVLPW {
        _AVLPW { w: self }
    }
    #[doc = "Bit 7 - Allow High Speed Run mode"]
    #[inline]
    pub fn ahsrun(&mut self) -> _AHSRUNW {
        _AHSRUNW { w: self }
    }
}
